SystemOrganization addCategory: #'StashShell-Core-Shell'!

Notification subclass: #StashShellNoSuchChild
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashShellNoSuchChild methodsFor: 'exceptiondescription' stamp: 'DaleHenrichs 12/11/2010 12:45'!
defaultAction

	^true! !

PPCompositeParser subclass: #StashArgsParser
	instanceVariableNames: 'options option keywordOption path pathTerm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashArgsParser methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 19:08'!
flatten: array into: flattenedOptions
	(array select: [ :a | a ~~ nil ])
		do: [ :arg | 
			arg isArray
				ifTrue: [self flatten: arg into: flattenedOptions]
				ifFalse: [ flattenedOptions add: arg ] ]! !

!StashArgsParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 18:54'!
keywordOption

	^ (($- asParser , #letter asParser plus) flatten , path optional) plus! !

!StashArgsParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 18:54'!
option

	^ path plus! !

!StashArgsParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 19:07'!
options
	^ (keywordOption optional , option optional , keywordOption optional) optional
		==> [ :optionArray | 
			| flattenedOptions |
			flattenedOptions := OrderedCollection new.
			self flatten: optionArray into: flattenedOptions.
			flattenedOptions asArray ]! !

!StashArgsParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 20:48'!
path

	^ (($/ asParser , (pathTerm delimitedBy: $/ asParser) optional) / (pathTerm delimitedBy: $/ asParser) / pathTerm) flatten trim! !

!StashArgsParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 20:47'!
pathTerm

	^ (#word asParser plus / '..' asParser plus / '.' asParser plus ) token ==> [:token | token value ]! !

!StashArgsParser methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:47'!
start

	^options end! !

PPCompositeParser subclass: #StashCommandParser
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashCommandParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 11:07'!
command

	^(#letter asParser , #word asParser star) token trim ==> [ :token | token value ]! !

!StashCommandParser methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:59'!
start

	^command and! !

Object subclass: #StashCommand
	instanceVariableNames: 'command options argumentsString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashCommand classSide methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/9/2010 14:12'!
command: commandName
	^(self new)
		command: commandName;
		yourself! !

!StashCommand methodsFor: 'errors' stamp: 'DaleHenrichs 12/12/2010 09:00'!
argsParsingError
	| stream |
	stream := WriteStream on: String new.
	stream
		nextPutAll: 'invalid arguments';
		cr;
		nextPutAll: self command , ': ' , self usage.
	self error: stream contents! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/12/2010 09:23'!
argumentsString

	^argumentsString! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 13:56'!
command
	^ command! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 13:56'!
command: anObject
	command := anObject! !

!StashCommand methodsFor: 'testing' stamp: 'DaleHenrichs 12/12/2010 08:57'!
debugFlag

	^self options includes: #'-d'.! !

!StashCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/12/2010 09:15'!
executeAgainst: aStashShellDevice in: aStashShell

	self subclassResponsibility! !

!StashCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/11/2010 10:28'!
executeIn: aShell withArgs: args

	self subclassResponsibility! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 18:13'!
getopts: args into: nonOptionArgs
	| argCount argIndex |
	argCount := args size.
	argIndex := 1.
	[ argIndex <= argCount ]
		whileTrue: [ 
			| arg |
			((arg := args at: argIndex) beginsWith: '-')
				ifTrue: [ argIndex := self handleOption: arg for: args at: argIndex ]
				ifFalse: [ 
					nonOptionArgs add: arg.
					argIndex := argIndex + 1 ] ]! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 14:12'!
handleOption: arg for: args at: argIndex
	(self validArgs includes: arg)
		ifFalse: [ self error: 'invalid option: ' , arg printString ].
	self options add: arg asSymbol.
	^argIndex + 1! !

!StashCommand methodsFor: 'errors' stamp: 'DaleHenrichs 12/12/2010 09:00'!
missingOperandError
	| stream |
	stream := WriteStream on: String new.
	stream
		nextPutAll: 'missing operand';
		cr;
		nextPutAll: self command, ': ' , self usageMessage.
	self error: stream contents! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 13:45'!
options
	options ifNil: [ options := OrderedCollection new ].
	^ options! !

!StashCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/12/2010 09:24'!
parse: argsString

	argumentsString := argsString.
	^self parser parse: argumentsString! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:08'!
parser

	^StashArgsParser new! !

!StashCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/12/2010 09:03'!
processArgs: argsString

	self subclassResponsibility! !

!StashCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/12/2010 09:12'!
selector

	^self subclassResponsibility! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:41'!
usage

	^self subclassResponsibility! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:54'!
usageMessage

	^self usage! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/12/2010 09:02'!
validArgs

	^#('-d')! !

Object subclass: #StashDevice
	instanceVariableNames: 'name parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashDevice classSide methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 13:52'!
isMountable

	^false! !

!StashDevice methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 12:13'!
children

	self subclassResponsibility! !

!StashDevice methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 12:10'!
hasChildNamed: aString

	^self children includesKey: aString! !

!StashDevice methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 14:42'!
isFolder

	^true! !

!StashDevice methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 15:07'!
isMountable

	^self class isMountable! !

!StashDevice methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 15:40'!
lookupChildNamed: aString ifAbsent: absentBlock
	^ (self shellDeviceClass new)
		object:
				(self children
						at: aString
						ifAbsent: [ 
							(StashShellNoSuchChild signal: aString)
								ifTrue: [ absentBlock value ]
								ifFalse: [ nil ] ]);
		name: aString;
		yourself! !

!StashDevice methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 09:46'!
name
	^ name! !

!StashDevice methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 09:45'!
name: anObject
	name := anObject! !

!StashDevice methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 12:14'!
object

	^self! !

!StashDevice methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 10:35'!
parent

	^parent! !

!StashDevice methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 10:35'!
parent: anObject
	parent := anObject! !

!StashDevice methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:40'!
shellDeviceClass

	^StashShellFolder! !

StashDevice subclass: #StashShellDevice
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashShellDevice methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 11:25'!
children

	self shouldNotImplement! !

!StashShellDevice methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 12:11'!
hasChildNamed: aString

	^self object hasChildNamed: aString! !

!StashShellDevice methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 14:41'!
isFolder

	self object == nil ifTrue: [ ^false ].
	^self object isFolder! !

!StashShellDevice methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:41'!
lookupChildNamed: aString ifAbsent: absentBlock
	^ (self object lookupChildNamed: aString ifAbsent: absentBlock)
		parent: self;
		yourself! !

!StashShellDevice methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 13:11'!
name
	
	name ifNil: [ ^self object name ].
	^ name! !

!StashShellDevice methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 10:36'!
object
	^ object! !

!StashShellDevice methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 10:36'!
object: anObject
	object := anObject! !

!StashShellDevice methodsFor: 'evaluation' stamp: 'DaleHenrichs 12/12/2010 09:26'!
performCommand: commandSymbol in: aStashShell withArgs: argsString
	| command |
	command := aStashShell builtinCommands
		at: commandSymbol
		ifAbsent: [ ^ 'The command ' , commandSymbol asString printString , ' was not found' ].
	[ 
	command processArgs: argsString.
	^ command executeAgainst: self in: aStashShell ]
		on: Error
		do: [ :ex | 
			command debugFlag
				ifTrue: [ self halt ].
			^ self command , ': ' , argsString , ': ' , ex messageText ]! !

StashShellDevice subclass: #StashShellFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashShellFile methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 15:35'!
hasChildNamed: aString

	^false! !

!StashShellFile methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 15:36'!
isFolder

	^false! !

!StashShellFile methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:37'!
lookupChildNamed: aString ifAbsent: absentBlock

	self shouldNotImplement! !

StashShellDevice subclass: #StashShellFolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

Object subclass: #StashShell
	instanceVariableNames: 'virtualMachine parser promptString path currentWorkingNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashShell classSide methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/11/2010 09:59'!
default

	^(self new)
		virtualMachine: StashNIXMachine new;
		yourself! !

!StashShell classSide methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/11/2010 10:00'!
executeScript: shellScript

	^(self default)
		executeScript: shellScript! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 10:01'!
builtinCommands

	^self virtualMachine builtinCommands! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 10:04'!
defaultPromptString

	^ '$ '! !

!StashShell methodsFor: 'initialize-release' stamp: 'DaleHenrichs 12/9/2010 16:47'!
executeScript: shellString
	| input output aCommandString str |
	input := ReadStream on: shellString.
	output := WriteStream on: String new.
	[ input atEnd ]
		whileFalse: [ 
			str := self processCommand: input nextLine.
			str isEmpty
				ifFalse: [ output nextPutAll: str ].
			output cr ].
	^ output contents! !

!StashShell methodsFor: 'private' stamp: 'DaleHenrichs 12/11/2010 11:31'!
newPath: workingPath fromTerms: terms
	| aString |
	terms isEmpty
		ifTrue: [ ^ workingPath ].
	aString := terms removeFirst.
	aString = '.'
		ifTrue: [ ^ self newPath: workingPath fromTerms: terms ].
	aString = '..'
		ifTrue: [ 
			workingPath size == 1
				ifTrue: [ ^ workingPath ].
			workingPath removeLast.
			^ self newPath: workingPath fromTerms: terms ].
	workingPath addLast: (workingPath last lookupChildNamed: aString ifAbsent: [ self error: 'No such file or directory' ]).
	^ self newPath: workingPath fromTerms: terms! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 10:41'!
parser

	parser ifNil: [ parser := StashCommandParser new ].
	^parser! !

!StashShell methodsFor: 'path accessing' stamp: 'DaleHenrichs 12/11/2010 11:08'!
path
	path ifNil: [ path := self rootPath ].
	^ path! !

!StashShell methodsFor: 'path accessing' stamp: 'DaleHenrichs 12/11/2010 14:40'!
path: aCollection
	aCollection
		do: [ :pathTerm | 
			pathTerm isFolder
				ifFalse: [ self error: pathTerm name , ' is not a folder' ] ].
	path := aCollection! !

!StashShell methodsFor: 'evaluation' stamp: 'DaleHenrichs 12/12/2010 08:49'!
processCommand: aCommandString
	"parse and execute the command in aCommandString"

	| result command args |
	result := self parser parse: aCommandString.
	result isPetitFailure
		ifTrue: [ ^ 'command parse failure: ' , aCommandString printString ].
	command := result.
	args := (aCommandString copyFrom: result size + 1 to: aCommandString size) withBlanksTrimmed.
	^ self path last performCommand: command asSymbol in: self withArgs: args! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 10:04'!
promptString
	"The primary command prompt string, equivalent to $PS1 in a Unix shell"

	^ promptString ifNil: [promptString := self defaultPromptString]
! !

!StashShell methodsFor: 'private' stamp: 'DaleHenrichs 12/11/2010 11:39'!
resolvePathFrom: aStashShellPath
	| workingPath |
	workingPath := aStashShellPath isAbsolute
		ifTrue: [ self rootPath ]
		ifFalse: [ self path ].
	^self newPath: workingPath copy fromTerms: aStashShellPath terms! !

!StashShell methodsFor: 'path accessing' stamp: 'DaleHenrichs 12/11/2010 11:51'!
resolvePathFromPathString: aPathString
	^ self resolvePathFrom: (StashShellPath fromString: aPathString)! !

!StashShell methodsFor: 'private' stamp: 'DaleHenrichs 12/11/2010 10:03'!
root
	^self virtualMachine root! !

!StashShell methodsFor: 'private' stamp: 'DaleHenrichs 12/11/2010 15:49'!
rootFolder
	^ (StashShellFolder new)
		object: self root;
		yourself! !

!StashShell methodsFor: 'private' stamp: 'DaleHenrichs 12/11/2010 12:04'!
rootPath
	^ OrderedCollection with: self rootFolder! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 09:58'!
virtualMachine
	^ virtualMachine! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 09:58'!
virtualMachine: anObject
	virtualMachine := anObject! !

Object subclass: #StashShellPath
	instanceVariableNames: 'isAbsolute pathTerms'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashShellPath classSide methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/9/2010 19:48'!
fromString: aString

	^(self new)
		isAbsolute: aString first = $/;
		pathTerms: (aString findTokens: '/');
		yourself! !

!StashShellPath methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 19:47'!
isAbsolute
	^ isAbsolute! !

!StashShellPath methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 19:47'!
isAbsolute: anObject
	isAbsolute := anObject! !

!StashShellPath methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 19:47'!
pathTerms
	^ pathTerms! !

!StashShellPath methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 19:55'!
pathTerms: aCollection
	pathTerms := aCollection asOrderedCollection! !

!StashShellPath methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 11:04'!
terms
	^ pathTerms! !

Object subclass: #StashVirtualMachine
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashVirtualMachine methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 09:57'!
builtinCommands

	^Dictionary new! !

!StashVirtualMachine methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 12:28'!
defaultRoot

	self subclassResponsibility! !

!StashVirtualMachine methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 12:29'!
root
	root ifNil: [ root := self defaultRoot ].
	^ root! !

!StashVirtualMachine methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 09:53'!
root: anObject
	root := anObject! !
